﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace DelayedInitialization
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        // Aside from "InitializeComponent", everything is this file is just for instrumenting 
        // the main window initialization time.
        //
        DateTime _StartTime;
        TimeSpan _Span;
        bool _first = true;

        public MainWindow()
        {           
            _StartTime = DateTime.Now;
            InitializeComponent();
        }

        protected override Size MeasureOverride(Size availableSize)
        {
            if (_first)
            {
                _Span = DateTime.Now - _StartTime;
                _first = false;
            }           
            return base.MeasureOverride(availableSize);
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            MessageBox.Show(string.Format(
                "Time from start of main window construction to start of layout: {0} seconds", _Span.Seconds + _Span.Milliseconds / 1000.0));            
        }
    }
}
