﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace DelayedInitialization
{
    /// <summary>
    /// Interaction logic for SimpleControl.xaml
    /// </summary>
    public partial class SimpleControl : Control
    {
        public SimpleControl()
        {
            // To enable a Control-derived class to use delayed initialization, the only change
            // you generally need to make is this one line: removing the call to InitializeComponent() and 
            // replacing it with InitializationOptions.Initialize(this). The handlers for the Initialized 
            // and Loaded events are optional parameters.
            //
            //IntializeComponent(); 
            //
            InitializationOptions.Initialize(this, SimpleControl_Initialized, SimpleControl_Loaded);
        } 
       
        void SimpleControl_Initialized(object sender, EventArgs e)
        {
        }

        void SimpleControl_Loaded(object sender, RoutedEventArgs e)
        {         
        }

        // The following 3 methods are not required to enable delayed initialization - they are provided so that you
        // can set breakpoints and see how the sequence of operations varies between immediate and delayed initialization.
        //
        // They are initially commented out in this example so that they do not throw off the results of speed testing.
        //
        /*protected override void OnPropertyChanged(DependencyPropertyChangedEventArgs e)
        {
            base.OnPropertyChanged(e);
        }

        protected override Size MeasureOverride(Size constraint)
        {            
            return base.MeasureOverride(constraint);
        }

        protected override Size ArrangeOverride(Size arrangeBounds)
        {
            return base.ArrangeOverride(arrangeBounds);
        }*/      
    }
}
